//+------------------------------------------------------------------+
//|                                                  SimbaSystem.mq4 |
//|                                      Simba, programmed by Malcik |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

#property copyright "Simba, programmed by Malcik"
#property link      "http://www.forex-tsd.com"

#define MAGICSS  20070129

extern bool    StopAfterNoTrades=false;
extern int     MA_Type=1;             // 1 for SATL, 2 for HULL MA, 3 for JMA
extern int     JMA_HMA_Period=13;     // When using JMA or HMA, set period here
extern double  JMA_Phase=0;           // When using JMA, set phase here
extern bool    UseSATLFilter=true;    // When true, the EA will only go long/short when the price is above/below SATL (or any other MA)
extern bool    AllowReentries=false;  // When true, more than 1 position can be open (reentries at each 10 pips of better price or after retracement of W%R)
extern int     WPR_Period=90;         // W%R period
extern int     ChandDist_Min=35;      // Boundaries of distances of price from Chandelier
extern int     ChandDist_Max=100;     // Self explanatory
extern int     TPPips=355;            // Self explanatory
extern double  LotSize=1;             // Self explanatory
extern int     MaximumRisk=0;         // Integer number of percent of the account you want to risk per trade; if 0, no money management used
extern int     pips=10;               // for reentry, it will buy/sell if it meet criteria and more than 10 pips different than last price ( default = 10 )
extern bool    check_spread=false;    // spread checking feature
extern int     spread_limit = 6;      // maximum allowable spread, default = 6 pips
extern int     wpr_top_limit=-5;      // wpr top limit, default = -5
extern int     wpr_bottom_limit=-95;  // wpr limit, default = -95
extern bool    atr_for_tp=true;       // use Average True Range (daily) for take profit
extern int     atr_period=106;        // self explanatory
extern int     atr_divider=4;         // take profit will be atr_period/atr_divider
extern bool    use_chandelier_if_touched=false; // if set to false, it will exit position if chandelier is touched, otherwise, it will check chandelier every our

string order_comment = "SimbaSystemM1";

/*
v1.2.a
======
- check for spread, is spread is bigger than usual, then exit
- change lot calculation from Integer to double
- check minimum/maximum allowable lot from broker and set to minimum/maximum if less/more than minimum/maximum
- fix the ordersend stop loss,for example, for long stop loss, it will 1 point + spread below the chandelier_dn
- make wpr limit for top (-5) & bottom (-95) as extern variable 
  also make the 10 pips as external variable, which is for reentry criteria
  ( maybe usefull for optimisation
- print ordersend error if there is order error
- adding posibility of using atr

v1.2.b
======
- add blocking to spread checking
- move the spread checking to ordersend part, so it will not block entire ea, but blocking ordersend only if spread is crazy
- add use_chandelier_if_touched feature, for stop loss purposes based on if touched or when chandelier change status at the end of the hour
*/

datetime LastMinute;
int      LongTrades=0;
int      ShortTrades=0;
double   LastBuyPrice=0;
double   LastSellPrice=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double SATL; //=iCustom(NULL,PERIOD_H4,"SATL",0,1);
   double SATL_Prev; //=iCustom(NULL,PERIOD_H4,"SATL",0,2);
   double Chandelier_Up=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",0,1);
   double Chandelier_Dn=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",1,1);
   double WPR=iWPR(NULL,0,WPR_Period,1);

   int    res;
   double spread;
   
     
   if (atr_for_tp)
     TPPips = NormalizeDouble((iATR(NULL,PERIOD_D1,atr_period,1)/Point)/atr_divider,0);
     
//----
   if(MA_Type==1)
     {
      SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
     }
   if(MA_Type==2)
     {
      SATL=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,2);
     }
   if(MA_Type==3)
     {
      SATL=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,2);
     }

   LongTrades=0;
   ShortTrades=0;

   if (OrdersTotal() == 0)
   {
      if (StopAfterNoTrades) { Comment("There are no trades open - Stop After No Trades"); return(0); }
   }

   if(OrdersTotal()>0)
   {
      for(int i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
              }
            if(OrderType()==OP_SELL)
              {
               if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
              }
           }
        }

      if (use_chandelier_if_touched) {
        for(i=0;i<OrdersTotal();i++)
          {
           if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
             {
              if(OrderType()==OP_BUY)
                {
                 if(OrderStopLoss()<Chandelier_Up-Point-spread)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Up-Point,OrderTakeProfit(),0,Yellow);
                }
              if(OrderType()==OP_SELL)
                {
                 if(OrderStopLoss()>Chandelier_Dn+Point+spread)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Dn+Point+spread,OrderTakeProfit(),0,Green);
                }
             }
          }
      }


      for(i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)LongTrades++;
            if(OrderType()==OP_SELL)ShortTrades++;
           }
        }
     }

   if(LastMinute!=Time[0]) {
      if(AllowReentries)
        {
         if(WPR>=wpr_top_limit)LongTrades=0;
         if(WPR<=wpr_bottom_limit)ShortTrades=0;
        }

      if( LongTrades==0 || 
          (Ask<=LastBuyPrice-pips*Point && AllowReentries)
        )
        {
         if(SATL>SATL_Prev && 
         (Close[0]>=SATL) // || !UseSATLFilter) 
         && Chandelier_Up!=EMPTY_VALUE 
         && Chandelier_Dn==EMPTY_VALUE 
         && Close[0]>=Chandelier_Up+ChandDist_Min*Point 
         && Close[0]<=Chandelier_Up+ChandDist_Max*Point 
         && WPR<=wpr_bottom_limit
         )
           {
           
            spread = Ask-Bid;
            // check the spread, if the spread is not good, then quit the EA
            if (check_spread && spread_limit*Point<spread) {
              Comment("EA is stopped, because spread is more than ",spread_limit, " pips");
              return(0);
            }
            
            if(MaximumRisk!=0)
              LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/(((Ask-(Chandelier_Up-Point))/Point)*10),2);
            if(LotSize<MarketInfo(Symbol(),MODE_MINLOT)) // check for minimum lot
              LotSize=MarketInfo(Symbol(),MODE_MINLOT);
            if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT)) // check for maximum lot
              LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
            double buy_price = Ask;
            if (use_chandelier_if_touched)
              res=OrderSend(Symbol(),OP_BUY,LotSize,buy_price,3,Chandelier_Up-Point,buy_price+(TPPips*Point)+spread,order_comment,MAGICSS,0,Blue);
            else
              res=OrderSend(Symbol(),OP_BUY,LotSize,buy_price,3,0,buy_price+(TPPips*Point)+spread,order_comment,MAGICSS,0,Blue);
            if(res > 0) {
              if (OrderSelect(res, SELECT_BY_TICKET, MODE_TRADES)) {
                Print("BUY order opened : ", OrderOpenPrice());          
	           } else {
	             Print("Error opening BUY order : ", ErrorDescription(GetLastError()));
	           }
            } 
            LongTrades++;
            LastBuyPrice=Ask;
           }
        }

      if( ShortTrades==0 || 
          (Bid>=LastSellPrice+pips*Point && AllowReentries)
        )
        {
         if(SATL<SATL_Prev 
            && (Close[0]<=SATL) // || !UseSATLFilter) 
            && Chandelier_Up==EMPTY_VALUE 
            && Chandelier_Dn!=EMPTY_VALUE 
            && Close[0]<=Chandelier_Dn-ChandDist_Min*Point 
            && Close[0]>=Chandelier_Dn-ChandDist_Max*Point
            && WPR>=wpr_top_limit
            )
           {
           
            spread = Ask-Bid;
            // check the spread, if the spread is not good, then quit the EA
            if (check_spread && spread_limit*Point<spread) {
              Comment("EA is stopped, because spread is more than ",spread_limit, " pips");
              return(0);
            } 

            if(MaximumRisk!=0)
              LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/((((Chandelier_Dn+Point+Point*4)-Bid)/Point)*10),2);
            if(LotSize<MarketInfo(Symbol(),MODE_MINLOT)) // check for minimum lot
              LotSize=MarketInfo(Symbol(),MODE_MINLOT);
            if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT)) // check for maximum lot
              LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
            double sell_price = Bid;
            if (use_chandelier_if_touched)
              res=OrderSend(Symbol(),OP_SELL,LotSize,sell_price,3,Chandelier_Dn+Point+spread,sell_price-(TPPips*Point)+spread,order_comment,MAGICSS,0,Red);
            else 
              res=OrderSend(Symbol(),OP_SELL,LotSize,sell_price,3,0,sell_price-(TPPips*Point)+spread,order_comment,MAGICSS,0,Red);
            if(res > 0) {
              if (OrderSelect(res, SELECT_BY_TICKET, MODE_TRADES)) {
                Print("SELL order opened : ", OrderOpenPrice());          
	           } else {
	             Print("Error opening SELL order : ", ErrorDescription(GetLastError()));
	           }
            }
            ShortTrades++;
            LastSellPrice=Bid;
           }
        }

      LastMinute=Time[0];
     }
     spread = Ask-Bid;
     if (StopAfterNoTrades) { Comment("Enabled Stop After No Trades - Balance: ", AccountBalance(), ", Equity: ", AccountEquity(), ", Leverage: ",AccountLeverage(), ", Lots: ",OrderLots(),  ", Spread: ", spread,  ", TP: ", TPPips); }
     else {     Comment("Balance: ", AccountBalance(), ", Equity: ", AccountEquity(), ", Leverage: ",AccountLeverage(), ", Lots: ",OrderLots(),  ", Spread: ", spread,  ", TP: ", TPPips);}


//----
   return(0);
  }
//+------------------------------------------------------------------+